=== debian/changelog ===
mkl-dnn (1.1.1-1) unstable; urgency=medium

  * New upstream version 1.1.1

 -- Mo Zhou <cdluminate@gmail.com>  Fri, 25 Oct 2019 12:05:58 +0800

mkl-dnn (1.1-3) unstable; urgency=medium

  * Update d/tests/testutil.sh and re-generate autopkgtest control file.
  * Switch buildsystem to cmake+ninja.

 -- Mo Zhou <cdluminate@gmail.com>  Sat, 19 Oct 2019 13:59:30 +0800

mkl-dnn (1.1-2) unstable; urgency=medium

  * Nolonger differentiate the arch/indep rules. (Fixes FTBFS on arch:all)
  * Bump debhelper compat level to 12.

 -- Mo Zhou <cdluminate@gmail.com>  Sat, 12 Oct 2019 15:34:48 +0800

mkl-dnn (1.1-1) unstable; urgency=medium

  * New upstream version 1.1
  * Update installation control files and long descriptions.
  * Refresh symbols and reflect SONAME change.
  * Starting with version 1.1 the library is renamed to DNNL.

 -- Mo Zhou <cdluminate@gmail.com>  Sun, 06 Oct 2019 15:17:00 +0800
